CREATE     FUNCTION MrktBsktCheck( @Unit varchar(4), @PromoItem varchar(5), @BEGDTE smalldatetime, @ENDDTE smalldatetime)
 RETURNS TABLE 
 AS
 RETURN
 (SELECT DISTINCT TRANS_NO,UNITNUM,INV_NUMBER,SALESDATE
 FROM tblTranMAINITEM
 WHERE	(INV_NUMBER = @PromoItem) AND
	(SALESDATE between @BEGDTE AND @ENDDTE) AND
	(UNITNUM = @Unit)
 )

GO


CREATE            FUNCTION [MrktBsktPromoTot]( @Unit varchar(4), @PromoItem varchar(5), @BEGDTE smalldatetime, @ENDDTE smalldatetime, @Item varchar(5))

RETURNS VARCHAR(6)

AS  
BEGIN



	RETURN( select sum(tblTranMAINItem.multiplier)/100 
		from tblTranMAINItem JOIN Dim_Unit ON (tblTranMAINItem.UnitNum = Dim_Unit.Unit_Number)
		WHERE
			(tblTranMAINItem.TRANS_NO IN (SELECT TRANS_NO FROM tmpMrktBskt WHERE Item=@PromoItem)) AND
		 	(tblTranMAINItem.UNITNUM = @UNIT or Dim_Unit.Unit_Region=@UNIT or Dim_Unit.Unit_District=@UNIT  or @UNIT='All') AND
			(tblTranMAINItem.SALESDATE >= @BEGDTE) AND
			(tblTranMAINItem.SALESDATE <= @ENDDTE) AND
			(tblTranMAINItem.INV_NUMBER = @ITEM) AND
			(tblTranMAINItem.DELETION = 0))

END

GO



CREATE       FUNCTION [MrktBsktItemTot]( @Unit varchar(4), @BEGINDATE smalldatetime, @ENDDATE smalldatetime, @Item varchar(5) )

RETURNS VARCHAR(6)

AS  
BEGIN

--	RETURN	(SELECT sum(tblTranCheck.No_In_Prty)
--		FROM tblTranCHECK JOIN tblTranMAINItem
--			ON	(tblTranMAINItem.UNITNUM = tblTranCHECK.UNITNUM) AND
--				(tblTranMAINITEM.SALESDATE = tblTranCHECK.SALESDATE) AND
--				(tblTranMAINITEM.TRANS_NO = tblTranCHECK.TRANS_NO)
--		WHERE	(tblTranCHECK.UNITNUM = @UNIT) AND
--			(tblTranMAINItem.INV_NUMBER = @ITEM) AND
--			(tblTranCHECK.SALESDATE >= @BEGINDATE) AND
--			(tblTranCHECK.SALESDATE <= @ENDDATE))
--
	RETURN	(SELECT SUM( (MULTIPLIER/100) )
		FROM tblTranMAINItem JOIN Dim_Unit ON (tblTranMAINItem.UnitNum = Dim_Unit.Unit_Number)
		WHERE 	(unitnum = @UNIT or Dim_Unit.Unit_Region=@UNIT or Dim_Unit.Unit_District=@UNIT  or @UNIT='All') AND
			(inv_number = @ITEM) AND
			(salesdate >= @BEGINDATE) AND 
			(salesdate <= @ENDDATE) AND
			(deletion = 0) )

END


GO

CREATE TABLE [tmpMrktBskt] (
	[TRANS_NO] [float] NULL ,
	[Item] [varchar] (4) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
GO


CREATE          VIEW vwCheckMainItem 
AS

SELECT DISTINCT  tblTranMAINITEM.UNITNUM,
		tblTranMAINITEM.SALESDATE,
		tblTranMAINITEM.TRANS_NO,
		tblTranMAINITEM.CHECK_NO,
		tblTranMAINITEM.INV_NUMBER

FROM	tblTranMAINITEM
	




GO



CREATE PROCEDURE [dbo].[GetMarketBasketReport]
(
	@BEGINDATE datetime = NULL,
	@ENDDATE datetime = NULL,
	@UNIT varchar(255) = NULL,
	@ITEM varchar(255) = NULL
)
AS
/*********************************************************************
* Procedure: spMBAnalysis (spMarketBasketAnalysis)
*
* Created: 08/2006 cB
*
* Description: This procedure returns data for the Market Basket Analysis Report.
*
**********************************************************************
*/


DECLARE @TGOverall integer			-- Total Guests overall
DECLARE @TCOverall integer			-- Total Checks overall
DECLARE @AmtOverAll float			-- Total $ overall including Market Item

DECLARE @TGItem integer				-- Total Guests with Market Item
DECLARE @TCItem integer				-- Total Checks with Market Item
DECLARE @TotOfPromoItem integer			-- Total Number of promo items
DECLARE @TotAmtItem float 			-- Total $ of Market Item

DECLARE @ItemDesc char(25)			-- Market Item description
DECLARE @UnitDesc char(25)			-- Restaurant Unit description

DECLARE @TRANS_NO char(6)

--*************************************************************************************************************************
SET @TGOverall=		(SELECT sum(No_In_Prty)
			FROM  tblTranCheck JOIN Dim_Unit ON (tblTranCheck.UnitNum = Dim_Unit.Unit_Number)
			WHERE	(Dim_Unit.Unit_Number=@UNIT or Dim_Unit.Unit_Region=@UNIT or Dim_Unit.Unit_District=@UNIT  or @UNIT='All') AND
				(tblTranCheck.SALESDATE >= @BEGINDATE) AND
				(tblTranCheck.SALESDATE <= @ENDDATE))

SET @TCOverall=		(SELECT count(*)
			FROM tblTranCHECK JOIN Dim_Unit ON (tblTranCheck.UnitNum = Dim_Unit.Unit_Number)
			WHERE	(Dim_Unit.Unit_Number=@UNIT or Dim_Unit.Unit_Region=@UNIT or Dim_Unit.Unit_District=@UNIT  or @UNIT='All') AND
				(tblTranCheck.SALESDATE >= @BEGINDATE) AND
				(tblTranCheck.SALESDATE <= @ENDDATE))

SET @AmtOverAll=	(SELECT sum(Amount)
			FROM  tblTranCheck JOIN Dim_Unit ON (tblTranCheck.UnitNum = Dim_Unit.Unit_Number)
			WHERE	(Dim_Unit.Unit_Number=@UNIT or Dim_Unit.Unit_Region=@UNIT or Dim_Unit.Unit_District=@UNIT  or @UNIT='All') AND
				(tblTranCheck.SALESDATE >= @BEGINDATE) AND
				(tblTranCheck.SALESDATE <= @ENDDATE))

--*************************************************************************************************************************
--SET @TGItem=		(SELECT sum(No_In_Prty)
--			FROM tblTranCheck a
--			WHERE	a.trans_No in 	(SELECT b.trans_No
--						FROM tblTranMainItem b
--						WHERE	b.UnitNum=@UNIT
--	 					AND b.SalesDate BETWEEN @BEGINDATE AND @ENDDATE
--						AND b.Inv_Number=@ITEM )
--				AND a.Check_No in (SELECT b.Check_No
--						FROM tblTranMainItem b
--						WHERE	b.UnitNum=@UNIT
--	 					AND b.SalesDate BETWEEN @BEGINDATE AND @ENDDATE
--						AND b.Inv_Number=@ITEM )
--				AND a.UnitNum=@UNIT
--				AND a.salesdate BETWEEN @BEGINDATE AND @ENDDATE)


--SET @TCItem=		(SELECT count(*)
--			FROM	tblTranCheck a
--			WHERE	a.trans_No in	(SELECT b.trans_No
--						FROM tblTranMainItem b
--						WHERE	b.UnitNum=@UNIT
--	 					AND b.SalesDate BETWEEN @BEGINDATE AND @ENDDATE
--						AND b.Inv_Number=@ITEM)
--				AND a.Check_No in (SELECT b.Check_No
--						FROM tblTranMainItem b
--						WHERE	b.UnitNum=@UNIT
--	 					AND b.SalesDate BETWEEN @BEGINDATE AND @ENDDATE
--						AND b.Inv_Number=@ITEM )
--				AND a.UnitNum=@UNIT
--				AND a.salesdate BETWEEN @BEGINDATE AND @ENDDATE)


--SET @TotAmtItem=		(SELECT sum(Amount)
--			FROM	tblTranCheck a
--			WHERE	a.trans_No in	(SELECT b.trans_No
--						FROM tblTranMainItem b
--						WHERE	b.UnitNum=@UNIT
--	 					AND b.SalesDate BETWEEN @BEGINDATE AND @ENDDATE
--						AND b.Inv_Number=@ITEM)
--				AND a.Check_No in (SELECT b.Check_No
--						FROM tblTranMainItem b
--						WHERE	b.UnitNum=@UNIT
--	 					AND b.SalesDate BETWEEN @BEGINDATE AND @ENDDATE
--						AND b.Inv_Number=@ITEM )
--				AND a.UnitNum=@UNIT
--				AND a.salesdate BETWEEN @BEGINDATE AND @ENDDATE)

--* * * * * * *
--(SELECT @TGItem = sum(No_In_Prty), @TCItem = count(*), @TotAmtItem = sum(a.Amount)
--			FROM tblTranCheck a  JOIN Dim_Unit ON (a.UnitNum = Dim_Unit.Unit_Number)
--			WHERE	a.trans_No in 	(SELECT b.trans_No
--						FROM tblTranMainItem b JOIN Dim_Unit ON (b.UnitNum = Dim_Unit.Unit_Number)
--						WHERE	(b.UnitNum=@UNIT or Dim_Unit.Unit_Region=@UNIT or Dim_Unit.Unit_District=@UNIT or @UNIT='All')
--	 					AND b.SalesDate BETWEEN @BEGINDATE AND @ENDDATE
--						AND b.Inv_Number=@ITEM )
--				AND a.Check_No in (SELECT b.Check_No 
--						FROM tblTranMainItem b JOIN Dim_Unit ON (b.UnitNum = Dim_Unit.Unit_Number)
--						WHERE	(b.UnitNum=@UNIT or Dim_Unit.Unit_Region=@UNIT or Dim_Unit.Unit_District=@UNIT or @UNIT='All')
--	 					AND b.SalesDate BETWEEN @BEGINDATE AND @ENDDATE
--						AND b.Inv_Number=@ITEM )
--				AND (a.UnitNum=@UNIT or Dim_Unit.Unit_Region=@UNIT or Dim_Unit.Unit_District=@UNIT  or @UNIT='All') 
--				AND a.salesdate BETWEEN @BEGINDATE AND @ENDDATE )

(SELECT @TGItem=sum(b.No_In_Prty), @TCItem= count(*), @TotAmtItem=sum(b.Amount)
FROM
	vwCheckMainItem a
	LEFT OUTER JOIN tblTranCheck b ON (a.UNITNUM=b.UNITNUM AND a.SALESDATE=b.SALESDATE AND a.Trans_No=b.Trans_No AND a.Check_No=b.Check_No)
	INNER JOIN Dim_Unit ON (a.UnitNum = Dim_Unit.Unit_Number)
WHERE
	(Dim_Unit.Unit_Number=@UNIT or Dim_Unit.Unit_Region=@UNIT or Dim_Unit.Unit_District=@UNIT  or @UNIT='All') AND
	a.SalesDate BETWEEN @BEGINDATE AND @ENDDATE
	AND a.Inv_Number=@ITEM
)

SET @ItemDesc=		(SELECT DISTINCT tblFCOSTN.DESCR 
			FROM  tblFCOSTN JOIN Dim_Unit ON (tblFCOSTN.UnitNum = Dim_Unit.Unit_Number)
			WHERE	(tblFCOSTN.UNITNUM=@UNIT or Dim_Unit.Unit_Region=@UNIT or Dim_Unit.Unit_District=@UNIT  or @UNIT='All') AND 
				(tblFCOSTN.INV_NUMBER = @ITEM))

SET @UnitDesc=		(SELECT Unit_Description
			FROM Dim_Unit
			WHERE (Unit_Number = @UNIT))

	IF OBJECT_ID('tmpMrktBskt','table') IS NOT NULL
		DELETE tmpMrktBskt WHERE Item = @ITEM
	ELSE
		CREATE TABLE tmpMrktBskt (TRANS_NO float, Item varchar(4))	

	INSERT tmpMrktBskt	SELECT DISTINCT TRANS_NO,@ITEM as Item
				FROM tblTranMAINITEM JOIN Dim_Unit ON (tblTranMAINITEM.UnitNum = Dim_Unit.Unit_Number)
				WHERE	(UNITNUM = @UNIT or Dim_Unit.Unit_Region=@UNIT or Dim_Unit.Unit_District=@UNIT  or @UNIT='All') AND
					(SALESDATE >= @BEGINDATE) AND
					(SALESDATE <= @ENDDATE )AND
					(INV_NUMBER = @ITEM)
				ORDER BY TRANS_NO


SET @TotOfPromoItem=	dbo.MrktBsktPromoTot( @UNIT,@ITEM,@BEGINDATE,@ENDDATE,@ITEM)
--SELECT MrktBsktPromoTot( @UNIT,@ITEM,@BEGINDATE,@ENDDATE,@ITEM) as @TotOfPromoItem

--select DISTINCT TRANS_NO,'2268' as Item INTO tmpMrktBskt
--FROM tblTranMAINITEM
--WHERE	(UNITNUM = '011') AND
--	(SALESDATE >= '2006-08-01') AND
--	(SALESDATE <= '2006-08-01')AND
--	(INV_NUMBER = '2268')
--ORDER BY TRANS_NO
--***********************************************************************************************************
SELECT	@TGOverall as TotalGuestsOverall,
	@TCOverall as TotalChecksOverall,
	@TGItem as TotalGuestsByItem,
	@TCItem as TotalChecksByItem,
	@TotOfPromoItem as TotalOfPromoItem,	

	@TotAmtItem /  @TGItem as PromoAvgGuest,

	@TotAmtItem / @TCItem as PromoAvgCheck,

	@AmtOverAll / @TGOverall as OverallGuestAvg,
	@AmtOverAll / @TCOverall as OverallCheckAvg,

	@ItemDesc as ItemDesc,
	@UnitDesc as UnitDesc,

	tblNameMAJ.Name,
	tblTranMAINITEM.INV_NUMBER,
	tblFCOSTN.DESCR,
	dbo.MrktBsktItemTot(@UNIT,@BEGINDATE,@ENDDATE,tblTranMAINItem.INV_NUMBER) as MMX1,
--	dbo.MrktBsktPromoTot( @UNIT,@ITEM,@BEGINDATE,@ENDDATE,tblTranMAINItem.INV_NUMBER) as MMX2
	sum(tblTranMainItem.Multiplier)/100 as MMX2
	

FROM	vwCheckMainItem 
	JOIN tblTranMAINITEM
		ON	(vwCheckMainItem.UNITNUM = tblTranMAINITEM.UNITNUM) AND
			(vwCheckMainItem.SALESDATE = tblTranMAINITEM.SALESDATE) AND
			(vwCheckMainItem.TRANS_NO = tblTranMAINITEM.TRANS_NO)
	JOIN Dim_Unit 
		ON	(vwCheckMainItem.UNITNUM = Dim_Unit.Unit_Number)
	JOIN tblFCOSTN
		ON	(tblFCOSTN.UNITNUM = vwCheckMainItem.UNITNUM) AND
			(tblFCOSTN.INV_NUMBER = tblTranMAINITEM.INV_NUMBER)
	JOIN tblNameMAJ
		ON	(tblNameMAJ.UNITNUM = vwCheckMainItem.UNITNUM) AND
			(tblNameMAJ.CODE = tblFCOSTN.MAJOR)

WHERE	(vwCheckMainItem.UNITNUM = @UNIT or Dim_Unit.Unit_Region=@UNIT or Dim_Unit.Unit_District=@UNIT  or @UNIT='All')
	AND (vwCheckMainItem.INV_NUMBER = @ITEM)
	AND (tblTranMAINITEM.SALESDATE >= @BEGINDATE)
	AND (tblTranMAINITEM.SALESDATE <= @ENDDATE)
	AND (vwCheckMainItem.Check_No = tblTranMainItem.Check_No)
	AND (tblTranMAINITEM.DELETION = 0)

GROUP BY
		tblNameMAJ.Name,
		tblTranMAINITEM.INV_NUMBER,
		tblFCOSTN.DESCR

ORDER BY	tblNameMAJ.NAME, tblTranMAINITEM.INV_NUMBER


DELETE tmpMrktBskt WHERE Item = @ITEM

GO